import logging
import datetime
from abc import ABC, abstractmethod


from promethist.common.utils import make_logger_name

logger = logging.getLogger(make_logger_name(__name__))


class Storage(ABC):
    def __init__(self, config):
        self.config = config

    @abstractmethod
    def get_model(self, _id, language, newer_than=datetime.datetime.min):
        raise NotImplementedError("You need to override this method.")

    @abstractmethod
    def save_model(self, _id, language, model):
        raise NotImplementedError("You need to override this method.")

    @abstractmethod
    def delete_model(self, _id, language):
        raise NotImplementedError("You need to override this method.")